//+------------------------------------------------------------------+
//|                                         TradeSwitch DLL for MQL4 |
//|                           Copyright  2008, Forexampletrades.com |
//|                                  http://www.forexampletrades.com |
//+------------------------------------------------------------------+
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
//#include <shlwapi.h>

#define MAX_KEY_LENGTH 255
#define MAX_VALUE_NAME 16383
#define MAX_MT4_VALUE_NAME 255
#define MT4_EXPFUNC __declspec(dllexport)

//MT4_EXPFUNC int __stdcall SetFlag(char *szName, int value);
//MT4_EXPFUNC int __stdcall GetFlag(char *szName);
MT4_EXPFUNC int __stdcall FlushSignal(char *szName);
MT4_EXPFUNC int __stdcall SendSignal(char *szName, char *szValue);
MT4_EXPFUNC char* __stdcall ReceiveSignal(char *szName);

int DeleteSignal(char *szName, char* szValue);
bool IsSortableDateTime(char* szDateTime);
bool SameDateTime(SYSTEMTIME time1, SYSTEMTIME time2);

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
BOOL APIENTRY DllMain(HANDLE hModule,DWORD ul_reason_for_call,LPVOID lpReserved)
{
   switch (ul_reason_for_call)
   {
      case DLL_PROCESS_ATTACH:
      case DLL_THREAD_ATTACH:
      case DLL_THREAD_DETACH:
      case DLL_PROCESS_DETACH:
         break;
   }
   return(TRUE);
}

//MT4_EXPFUNC int __stdcall SetFlag(char *szName, int value)
//{
//   HKEY hKeyTradeSwitch;
//   HKEY hKeyTradeSwitch1;
//   HKEY hKeyTradeSwitch2;
//   bool RegisteredOK = false;
//   const char *szValue = (value == 0) ? "0" : "1";
//
//   if ( RegOpenKeyEx( HKEY_CURRENT_USER,
//      "Software\\",
//      0,
//      KEY_WRITE,
//      &hKeyTradeSwitch) == ERROR_SUCCESS)
//   {
//      if ( RegCreateKeyEx( hKeyTradeSwitch, 
//         "TradeSwitch",
//         0,
//         NULL,
//         REG_OPTION_NON_VOLATILE,
//         KEY_WRITE,
//         NULL,
//         &hKeyTradeSwitch1,
//         NULL) == ERROR_SUCCESS)
//      {
//         if ( RegCreateKeyEx( hKeyTradeSwitch1,
//            "Flags",
//            0,
//            NULL,
//            REG_OPTION_NON_VOLATILE,
//            KEY_WRITE,
//            NULL,
//            &hKeyTradeSwitch2,
//            NULL) == ERROR_SUCCESS)
//         {
//            if ( RegSetValueEx(hKeyTradeSwitch2,
//               szName,
//               0,
//               REG_SZ,
//               (LPBYTE) szValue,
//               (DWORD) lstrlen(szValue)+1) == ERROR_SUCCESS)
//            {
//               RegisteredOK = true;
//            }
//            RegCloseKey( hKeyTradeSwitch2 );
//         }
//         RegCloseKey( hKeyTradeSwitch1 );
//      }
//      RegCloseKey( hKeyTradeSwitch );
//   }
//   return RegisteredOK ? TRUE : FALSE;
//}
//
//MT4_EXPFUNC int __stdcall GetFlag(char *szName)
//{
//   try
//   {
//      char value[255];
//      DWORD dwType, dwSize = sizeof(value) - 1;
//
//      if ( SHGetValue(HKEY_CURRENT_USER,
//         "Software\\TradeSwitch\\Flags\\",
//         szName,
//         &dwType,
//         value,
//         &dwSize) == ERROR_SUCCESS)
//      {
//         if (strcmp(value, "0") == 0)
//         {
//            return 0;
//         }
//         if (strcmp(value, "1") == 0)
//         {
//            return 1;
//         }
//      }
//      return -1;
//   }
//   catch(...)
//   {
//   }
//   return -1;
//}

MT4_EXPFUNC int __stdcall FlushSignal(char *szName)
{
   int regCode = ERROR_SUCCESS;
   HKEY hKeyTradeSwitch;
   HKEY hKeyTradeSwitch1;
   DWORD cSubKeys = 0;
   DWORD cbMaxSubKey;
   DWORD cValues;
   DWORD cchMaxValue;
   char nextValue[MAX_VALUE_NAME];
   char nextData[MAX_VALUE_NAME];
   DWORD cchValue = MAX_VALUE_NAME;
   DWORD cchData = MAX_VALUE_NAME;
   bool FlushedOK = true;

   if ( RegOpenKeyEx( HKEY_CURRENT_USER,
      "Software\\TradeSwitch\\Signals\\",
      0,
      KEY_READ,
      &hKeyTradeSwitch) == ERROR_SUCCESS)
   {
      if ( RegOpenKeyEx( hKeyTradeSwitch,
         szName,
         0,
         KEY_ALL_ACCESS,
         &hKeyTradeSwitch1) == ERROR_SUCCESS)
      {
         regCode = RegQueryInfoKey( hKeyTradeSwitch1,
            NULL,
            NULL,
            NULL,
            &cSubKeys,
            &cbMaxSubKey,
            NULL,
            &cValues,
            &cchMaxValue,
            NULL,
            NULL,
            NULL);
         if (regCode == ERROR_SUCCESS)
         {
            if (cValues > 0)
            {
               for (int i = cValues - 1; i >= 0; i--) 
               {
                  cchValue = MAX_VALUE_NAME; 
                  nextValue[0] = '\0'; 
                  if (RegEnumValue( hKeyTradeSwitch1, i, 
                      nextValue, 
                      &cchValue, 
                      NULL, 
                      NULL,
                      (LPBYTE)nextData,
                      &cchData) == ERROR_SUCCESS)
                  {
                     if (IsSortableDateTime(nextValue))
                     {
                        if ( RegDeleteValue( hKeyTradeSwitch1,
                           nextValue) != ERROR_SUCCESS)
                        {
                           FlushedOK = false;            
                        }
                     }
                  }
               }
            }
         }
         RegCloseKey( hKeyTradeSwitch1 );
      }
      RegCloseKey( hKeyTradeSwitch );
   }
   return FlushedOK ? 0 : -1;
}

SYSTEMTIME lastdatetime;

MT4_EXPFUNC int __stdcall SendSignal(char *szName, char *szValue)
{
   HKEY hKeyTradeSwitch;
   HKEY hKeyTradeSwitch1;
   HKEY hKeyTradeSwitch2;
   HKEY hKeyTradeSwitch3;
   bool RegisteredOK = false;

   if ( RegOpenKeyEx( HKEY_CURRENT_USER,
      "Software\\",
      0,
      KEY_WRITE,
      &hKeyTradeSwitch) == ERROR_SUCCESS)
   {
      if ( RegCreateKeyEx( hKeyTradeSwitch, 
         "TradeSwitch",
         0,
         NULL,
         REG_OPTION_NON_VOLATILE,
         KEY_WRITE,
         NULL,
         &hKeyTradeSwitch1,
         NULL) == ERROR_SUCCESS)
      {
         if ( RegCreateKeyEx( hKeyTradeSwitch1,
            "Signals",
            0,
            NULL,
            REG_OPTION_NON_VOLATILE,
            KEY_WRITE,
            NULL,
            &hKeyTradeSwitch2,
            NULL) == ERROR_SUCCESS)
         {
            if ( RegCreateKeyEx( hKeyTradeSwitch2,
               szName,
               0,
               NULL,
               REG_OPTION_NON_VOLATILE,
               KEY_WRITE,
               NULL,
               &hKeyTradeSwitch3,
               NULL) == ERROR_SUCCESS)
            {
               char szDate[11];//yyyy-MM-dd
               char szTime[9];//hh:mm:ss
               char szMilliSeconds[5];//:xxx
               char szDateTime[24];//yyyy-MM-ddThh:mm:ss:xxx
               SYSTEMTIME datetime;
               do
               {
                  GetSystemTime(&datetime);
               }
               while (SameDateTime(lastdatetime, datetime));
               lastdatetime = datetime;
               GetDateFormat(LOCALE_USER_DEFAULT, NULL, &datetime,
                  "yyyy-MM-dd", szDate, sizeof(szDate)+1);
               GetTimeFormat(LOCALE_USER_DEFAULT, NULL, &datetime,
                  "HH:mm:ss", (LPSTR)szTime, 100);
               sprintf(szMilliSeconds, ":%03d", datetime.wMilliseconds);
               strcpy(szDateTime, szDate);
               strncat(szDateTime, "T", 1);
               strncat(szDateTime, szTime, 8);
               strncat(szDateTime, szMilliSeconds, 4);

               if ( RegSetValueEx(hKeyTradeSwitch3,
                  szDateTime,
                  0,
                  REG_SZ,
                  (LPBYTE) szValue,
                  (DWORD) lstrlen(szValue)+1) == ERROR_SUCCESS)
               {
                  RegisteredOK = true;
               }
               RegCloseKey( hKeyTradeSwitch3 );
            }
            RegCloseKey( hKeyTradeSwitch2 );
         }
         RegCloseKey( hKeyTradeSwitch1 );
      }
      RegCloseKey( hKeyTradeSwitch );
   }
   return RegisteredOK ? TRUE : FALSE;
}

MT4_EXPFUNC char* __stdcall ReceiveSignal(char *szName)
{
   int regCode = ERROR_SUCCESS;
   HKEY hKeyTradeSwitch;
   HKEY hKeyTradeSwitch1;
   HKEY hKeyTradeSwitch2;
   HKEY hKeyTradeSwitch3;
   DWORD cSubKeys = 0;
   DWORD cbMaxSubKey;
   DWORD cValues;
   DWORD cchMaxValue;
   char nextValue[MAX_VALUE_NAME];
   char firstValue[MAX_VALUE_NAME];
   char nextData[MAX_VALUE_NAME];
   char firstData[MAX_VALUE_NAME];
   char szData[MAX_MT4_VALUE_NAME];
   DWORD cchValue = MAX_VALUE_NAME;
   DWORD cchData = MAX_VALUE_NAME;
   bool ReceivedOK = false;
   try
   {
      if ( RegOpenKeyEx( HKEY_CURRENT_USER,
         "Software\\TradeSwitch\\Signals\\",
         0,
         KEY_READ,
         &hKeyTradeSwitch) == ERROR_SUCCESS)
      {
         if ( RegOpenKeyEx( hKeyTradeSwitch,
            szName,
            0,
            KEY_QUERY_VALUE,
            &hKeyTradeSwitch1) == ERROR_SUCCESS)
         {
            regCode = RegQueryInfoKey( hKeyTradeSwitch1,
               NULL,
               NULL,
               NULL,
               &cSubKeys,
               &cbMaxSubKey,
               NULL,
               &cValues,
               &cchMaxValue,
               NULL,
               NULL,
               NULL);
            if (regCode == ERROR_SUCCESS)
            {
               int firstIndex = -1;
               bool firstTime = true;
               for (int i = 0; i < cValues; i++) 
               {
                  cchValue = MAX_VALUE_NAME; 
                  nextValue[0] = '\0'; 
                  if (RegEnumValue( hKeyTradeSwitch1, i, 
                      nextValue, 
                      &cchValue, 
                      NULL, 
                      NULL,
                      (LPBYTE)nextData,
                      &cchData) == ERROR_SUCCESS)
                  {
                     if (IsSortableDateTime(nextValue))
                     {
                        if (strcmp(nextValue, firstValue) < 0 || firstTime)
                        {
                           firstTime = false;
                           strcpy(firstValue, nextValue);
                           strcpy(firstData, nextData);
                           firstIndex = i;
                        }
                     }
                  }
               }
               if (firstIndex >= 0)
               {
                  strncpy(szData, firstData, MAX_MT4_VALUE_NAME);
                  ReceivedOK = true;
               }
            }
            RegCloseKey( hKeyTradeSwitch1 );
         }
         RegCloseKey( hKeyTradeSwitch );
      }
      if (ReceivedOK)
      {
         DeleteSignal(szName, firstValue);
      }
      return ReceivedOK ? szData : "";
   }
   catch(...)
   {
   }
   return "";
}

int DeleteSignal(char *szName, char* szValue)
{
   HKEY hKeyTradeSwitch;
   HKEY hKeyTradeSwitch1;
   bool DeletedOK = false;

   if ( RegOpenKeyEx( HKEY_CURRENT_USER,
      "Software\\TradeSwitch\\Signals\\",
      0,
      KEY_WRITE,
      &hKeyTradeSwitch) == ERROR_SUCCESS)
   {
      if ( RegOpenKeyEx( hKeyTradeSwitch,
         szName,
         0,
         KEY_WRITE,
         &hKeyTradeSwitch1) == ERROR_SUCCESS)
      {
         if ( RegDeleteValue( hKeyTradeSwitch1,
            szValue) == ERROR_SUCCESS)
         {
            DeletedOK = true;            
         }
         RegCloseKey( hKeyTradeSwitch1 );
      }
      RegCloseKey( hKeyTradeSwitch );
   }
   return DeletedOK ? 0 : -1;
}

bool SameDateTime(SYSTEMTIME time1, SYSTEMTIME time2)
{
   if (time1.wYear != time2.wYear) return false;
   if (time1.wMonth != time2.wMonth) return false;
   if (time1.wDay != time2.wDay) return false;
   if (time1.wHour != time2.wHour) return false;
   if (time1.wMinute != time2.wMinute) return false;
   if (time1.wSecond != time2.wSecond) return false;
   if (time1.wMilliseconds != time2.wMilliseconds) return false;
   return true;
}

bool IsSortableDateTime(char* szDateTime)
{
   if (strlen(szDateTime) != 23) return false;
   for (int i = 0; i < 23; i++)
   {
      switch (i)
      {
      case 4:
      case 7:
         if (szDateTime[i] != '-') return false;
         break;
      case 10:
         if (szDateTime[i] != 'T') return false;
         break;
      case 13:
      case 16:
      case 19:
         if (szDateTime[i] != ':') return false;
         break;
      default:
         if (szDateTime[i] < '0' || szDateTime[i] > '9') return false;
         break;
      }
   }
   return true;
}
